/********************************************************
 * Experimentelle Implementierung einer lokalisierbaren	*
 * printf-Version mit der Sonderfunktion "%()"		*
 ********************************************************/

#include <windows.h>
#include <stdio.h>

void charcopy(char*& d,const char* s, const char*se) {
 size_t l=se-s;
 memcpy(d,s,l);
 d+=l;
}

int vlprintf(const char*s, va_list args) {
 char buf[1024], *d=buf;
 va_list src=args, dst=args;
 char c;
 for(;;) switch (c=*s++) {
  case 0: goto raus;
  case '%': {
   int dot=0,width[2]={0,0}, l=0;
   char*p=d;
   *d++=c;
   va_list va=dst;
   for(;;) switch (c=*s++) {
    case 0: goto raus;
    case '.': dot=1; goto save;
    case '*': va_arg(dst,int)=width[dot]=va_arg(src,int); goto save;
    case 'l': l++; goto save;		// "long"-Zhler
    case 'I':
    case 'L': l=2; goto save;
    case ' ':
    case '-':
    case '+':
    case 'h':
    case '#': save: *d++=c; break;	// sonstige Hilfszeichen zum CRT-printf() kopieren
    case 'p':
    case 'd':
    case 'i':
    case 'X':
    case 'x': if (l<2) {va_arg(dst,int)=va_arg(src,int); goto raus1;}	// sonst __int64 kopieren
    case 'E':
    case 'e':
    case 'F':
    case 'f':
    case 'G':
    case 'g': va_arg(dst,__int64)=va_arg(src,__int64); goto raus1;
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9': width[dot]=width[dot]*10+c-'0'; goto save;
    case '(': {
     const char *q=strchr(s,')');
     if (!q) goto raus1;
     d=p;
     dst=va;	// zurckstellen - '%' rausnehmen
     p=(char*)memchr(s,'/',q-s);	// Alternative
     int zahl=va_arg(src,int);
// Version deutsch/englisch
     if (zahl==1) {
      if (p) charcopy(d,s,p);
     }else{
      if (p) charcopy(d,p+1,q); 
      else charcopy(d,s,q);
     }
     s=q+1;
    }goto raus2;
    default: goto raus1;
   }
  }
raus1:
  default: *d++=c;
raus2:;
 }
raus:
 *d=c;
 return vprintf(buf,args);
}

int _cdecl lprintf(const char*s, ...) {
 return vlprintf(s,(va_list)(&s+1));
}

EXTERN_C void mainCRTStartup() {
 lprintf("Hallo %d Welt%(en)!\n",1,1);
 lprintf("Hallo %d Welt%(en)!\n",2,2);
 lprintf("Huch, %d %(Maus/M\x84use) im Zimmer %d!\n",1,1,13);
 lprintf("Huch, %d %(Maus/M\x84use) im Zimmer %d!\n",2,2,14);
 lprintf("%d %%\n",15);
}
